# Edit this file
# if You have Globus installed put here right location and flavour
# it is beter to use gcc32dbgpthr on Linux
GLOBUS_LOCATION=/opt/globus
GLOBUS_FLAVOR=gcc32dbgpthr
GPT_LOCATION=/opt/globus

# If You do NOT have gpt installed make following variable empty
USE_GLOBUS_GPT=$(GLOBUS_LOCATION)/bin/globus-makefile-header
#USE_GLOBUS_GPT=

# installation location - place where gm will be installed
NORDUGRID_LOCATION=/opt/nordugrid

# PBS option
PBS_LOCATION=/usr/local/openpbs
PBS_SPOOL=/var/spool/PBS

#runtime options
RUNTIME_CONFIG_DIR=/SOFTWARE/runtime
#RUNTIME_LOCAL_SCRATCH_DIR=/home/\\$$USER
RUNTIME_LOCAL_SCRATCH_DIR=
RUNTIME_FRONTEND_SEES_NODE=
RUNTIME_NODE_SEES_FRONTEND=yes

# Make it non-empty if You have Globus Replica Catalog client
# libraries installed.
USE_GLOBUS_RC=yes
#USE_GLOBUS_RC=

# Make it non-empty if You have Replica Location Service client
# libraries installed.
USE_GLOBUS_RLS=yes
#USE_GLOBUS_RLS=

# Make one othe non-empty empty to use VOMS patched by NG or EDG VOMS
#NG_VOMS=yes
#EDG_VOMS=yes
NG_VOMS=
EDG_VOMS=yes

# Make one othe non-empty empty to use GACL patched by NG or gridsite
#NG_GACL=yes
#GRIDSITE_GACL=yes
NG_GACL=yes
GRIDSITE_GACL=


# Edit these only if You have nonstandard placement of files
GLOBUS_LIBS=${GLOBUS_LOCATION}/lib
GLOBUS_INCLUDES=${GLOBUS_LOCATION}/include/${GLOBUS_FLAVOR}
PBS_BIN_PATH=${PBS_LOCATION}/bin
PBS_LOG_PATH=${PBS_SPOOL}/server_logs
GNU_TIME=/usr/bin/time
NODENAME="/bin/hostname -f"
TMP_DIR=/tmp

# Set it to empty if You do not have gSOAP installed
GSOAP_PATH=/usr/local
#GSOAP_PATH=

DEFINES=-DVERSION='"${VERSION}"' -DHAVE_MEMMOVE

# If You have gcc newer or starting from 2.96
DEFINES+=-DHAVE_SSTREAM -DHAVE_STRERROR_R -DHAVE_PTHREAD_YIELD

# If grid-manager and gridftpd have a lot of <defunct> children try this
# DEFINES+=-DNONPOSIX_SIGNALS_IN_THREADS

# Comment it for RedHat 6.2 
DEFINES+=-DHAVE_PTHREAD_YIELD

#use -DHAVE_GLOBUS_GSI_PROXY_H when linking against globus 2.2 and higher
DEFINES+=-DHAVE_GLOBUS_GSI_PROXY_H

#use -DOLD_GLOBUS_IO if You have globus_io version < 4.0 (Globus < 2.4)
# DEFINES+=-DOLD_GLOBUS_IO
# Alternatively You can define version of globus_io directly
# DEFINES+=-DGLOBUS_IO_VERSION=3  For old globus
# DEFINES+=-DGLOBUS_IO_VERSION=4  For 2.4.x (default)
# DEFINES+=-DGLOBUS_IO_VERSION=5  For 3.x


#use -DOLD_GSOAP if installed gSOAP have version < 2.4
#DEFINES+=-DOLD_GSOAP

#use CPPLIBS=-lstdc++ if Your Linux distribution has no static C++ libraries
CPPLIBS=-Wl,-Bstatic -lstdc++ -Wl,-Bdynamic


###############################################################
################### DO NOT EDIT BELOW #########################
###############################################################

DEFINES+=-DDEFAULT_GLOBUS_LOCATION=\"$(GLOBUS_LOCATION)\"

GLOBUS_RC_OBJECT=
ifneq (,$(USE_GLOBUS_RC))
DEFINES+=-DHAVE_GLOBUS_REPLICA_CATALOG_H
GLOBUS_RC_OBJECT=globus_replica_catalog
endif

GLOBUS_RLS_OBJECT=
ifneq (,$(USE_GLOBUS_RLS))
DEFINES+=-DHAVE_GLOBUS_RLS_CLIENT_H
GLOBUS_RLS_OBJECT=globus_rls_client
endif


CFLAGS=-g

ifneq (,$(GSOAP_PATH))
DEFINES+=-DHAVE_GSOAP
endif

ifeq (,$(GPT_LOCATION))
GPT_LOCATION=$(GLOBUS_LOCATION)
endif

ifneq (,$(USE_GLOBUS_RLS))
endif

ifneq (,$(NG_VOMS))
VOMS_PATH=../external/voms-1.1.39
DEFINES+=-DNG_VOMS
VOMS_LIB=
VOMS_OBJECTS=$(VOMS_PATH)/api/libvomsapi.a
else
ifneq (,$(EDG_VOMS))
VOMS_PATH=/opt/voms
DEFINES+=-DEDG_VOMS
VOMS_LIB=-L$(VOMS_PATH)/lib -lvomsapi_$(GLOBUS_FLAVOR)
VOMS_OBJECTS=
else
VOMS_PATH=
VOMS_LIB=
VOMS_OBJECTS=
endif
endif

ifneq (,$(NG_GACL))
GACL_PATH=../../external/gacl-0.1.5
DEFINES+=-DNG_GACL
GACL_LIB=`xml2-config --libs`
GACL_OBJECTS=$(GACL_PATH)/libgacl.a
else
ifneq (,$(GRIDSITE_GACL))
GACL_PATH=/opt/gridsite
DEFINES+=-DGRIDSITE_GACL
GACL_LIB=`xml2-config --libs`
GACL_OBJECTS=$(GACL_PATH)/lib/libgridsite.a
else
GACL_PATH=
GACL_LIB=
GACL_OBJECTS=
endif
endif
