#include "../std.h"
#include "conf.h"
// #include "../files/info_types.h"
#include "../misc/escaped.h"
#include "environment.h"

bool config_open(ifstream &cfile) {
  return config_open(cfile,nordugrid_config_loc);
}

bool config_open(ifstream &cfile,string &name) {
  cfile.open(name.c_str(),ifstream::in);
  return cfile.is_open();
}

bool config_close(ifstream &cfile) {
  if(cfile.is_open()) cfile.close();
  return true;
}

string config_read_line(istream &cfile,string &rest,char separator) {
  rest = config_read_line(cfile);
  return config_next_arg(rest,separator);
}

string config_read_line(istream &cfile) {
  string rest;
  for(;;) {
    if(cfile.eof()) { rest=""; return rest; };
    {
      char buf[256];
      istream_readline(cfile,buf,sizeof(buf));
      rest=buf;
    };
    int n=rest.find_first_not_of(" \t");
    if(n == string::npos) continue; /* empty string - skip */
    if(rest[n] == '#') continue; /* comment - skip */
    break;
  };
  return rest;
}

string config_next_arg(string &rest,char separator) {
  int n;
  string arg;
  n=input_escaped_string(rest.c_str(),arg,separator);
  rest=rest.substr(n);
  return arg;
}    


