#ifndef __GM_ENVIRONMENT_H__
#define __GM_ENVIRONMENT_H__

#include <string>

/// $GLOBUS_LOCATION, default /opt/globus */
extern string globus_loc;
/// $GLOBUS_LOCATION/libexec
extern string globus_scripts_loc;
/// $NORDUGRID_LOCATION, default /opt/nordugrid
extern string nordugrid_loc;
/// $NORDUGRID_LOCATION/bin
extern string nordugrid_bin_loc;
/// $NORDUGRID_LOCATION/libexec (mostly)
extern string nordugrid_libexec_loc;
/// $NORDUGRID_LOCATION/etc/grid-manager.conf or /etc/grid-manager.conf
/// or /etc/nordugrid.conf (central configuration)
extern string nordugrid_config_loc;
/// grid.manager@hostname, it can also be set from configuration file 
extern string support_mail_address;
/// $GRIDMAP, default /etc/grid-security/grid-mapfile
extern string globus_gridmap;
/// 
extern bool central_configuration;

/*
  Read environment, check files and set variables
  Accepts:
    guess - if false, default values are not allowed.
  Returns:
    true - success.
    false - something is missing.
*/
bool read_env_vars(bool guess = false);

#endif // __GM_ENVIRONMENT_H__
