#ifndef __DATABUFFER_H__
#define __DATABUFFER_H__

#include "../std.h"
#include <pthread.h>

/*
  Cyclic buffer to use during data transfer/move.
  Not used. Look for DataBufferPar .
*/

class DataBuffer {
 private:
  long long int start;
  long long int end;
  long long int read_start;
  long long int read_length;
  bool valid;
  unsigned int size;
  unsigned int subsize;
  char* buf;
  pthread_mutex_t lock;
 public:
  DataBuffer(unsigned int size);
  ~DataBuffer(void);
  /* provide buffer for READING INTO IT */
  bool for_read(char** start,unsigned int *length);
  bool is_read(unsigned int length);
  /* provide buffer for WRITING FROM IT */
  bool for_write(char** start,unsigned int *length);
  bool is_written(unsigned int length);
  operator bool(void) { return (buf!=0); };
};

#endif
