#include "../../std.h"

#include <globus_common.h>
#include <globus_io.h>
#include <fstream>
#include <iostream>

#include "srm_soap.nsmap"

#include "../client/client.h"

SOAP_NMAC struct Namespace namespaces[] =
{
  {NULL, NULL}
};

HTTP_ClientSOAP *s;

bool test = false;


int main(int argc,char* argv[]) {
  char* url = argv[1];
  if(url == NULL) { cerr<<"URL missing"<<endl; return -1; };
  char* lfn = argv[2];
  if(lfn == NULL) { cerr<<"LFN missing"<<endl; return -1; };
  int ret = -1;

  if(globus_module_activate(GLOBUS_IO_MODULE) != GLOBUS_SUCCESS) {
    cerr<<"Failed to activate globus"<<endl; return -1;
  };

  struct soap soap;

  int soap_err = SOAP_OK;

  // initialize interface
  s = new HTTP_ClientSOAP(url,&soap);
  soap.namespaces=srm_soap_namespaces;

  if(s->connect() != 0) {
    cerr<<"Failed to connect to "<<url<<endl;
    return -1;
  };

  srm1__srmLsRequest* req   = soap_new_srm1__srmLsRequest(&soap,-1);
  srm1__srmLsResponse* resp = soap_new_srm1__srmLsResponse(&soap,-1);
  struct srm1__srmLsResponse_ r;
  r.srmLsResponse=resp;
  req->authorizationID=NULL; // srm1__TUserID
  req->paths=soap_new_ArrayOfTSURLInfo(&soap,-1);
  req->paths->__size=1;
  srm1__TSURLInfo* path = soap_new_srm1__TSURLInfo(&soap,-1);
  req->paths->__ptr=&path;
  req->paths->__ptr[0]->storageSystemInfo=NULL;
  req->paths->__ptr[0]->SURLOrStFN=soap_new_srm1__TSURL(&soap,-1);
  req->paths->__ptr[0]->SURLOrStFN->value=lfn;
  srm1__TFileStorageType type = Permanent_; req->fileStorageType=&type;
  req->fullDetailedList=NULL; // bool
  req->allLevelRecursive=NULL; // bool
  req->numOfLevels=NULL; // int
  int offset = 0; req->offset=&offset;
  int count = 1000; req->count=&count;

  if((soap_err=soap_call_srm1__srmLs(&soap,url,NULL,req,r)) != SOAP_OK) {
    cerr<<"Failed to iquery remote file: "<<soap_err<<endl;
  } else if(r.srmLsResponse == NULL) {
    cerr<<"There is no response"<<endl;
  } else {
    if(r.srmLsResponse->returnStatus == NULL) cerr<<"There is no status"<<endl;
    if(r.srmLsResponse->details == NULL) {
      cerr<<"There are no details"<<endl;
    } else if(r.srmLsResponse->details->__size == 0) {
      cerr<<"Zero details"<<endl;
    } else if(r.srmLsResponse->details->__ptr == NULL) {
      cerr<<"Empty array"<<endl;
    } else {
      for(int i=0;i<r.srmLsResponse->details->__size;i++) {
        cerr<<i<<":";
        if(r.srmLsResponse->details->__ptr[i]->path)
              cerr<<r.srmLsResponse->details->__ptr[i]->path;
        cerr<<":";
        if(r.srmLsResponse->details->__ptr[i]->size)
              cerr<<r.srmLsResponse->details->__ptr[i]->size->value;
        cerr<<endl;
      };
    };
  };

/*
  ns__fileinfo info;
  unsigned long long int size_ = 2000;
  info.id=lfn; info.size=&size_;
  info.checksum=NULL;
  info.acl="<?xml version=\"1.0\"?><gacl version=\"0.0.1\"><entry><any-user></any-user><allow><write/><read/><list/><admin/></allow></entry></gacl>";
  ns__addResponse rr;
  if((soap_err=soap_call_ns__add(&soap,url,"add",&info,1,&source,rr)) != SOAP_OK) {
    cerr<<"Failed to create remote file: "<<soap_err<<endl;
  } else {
    cerr<<"Returned: error code "<<rr.error_code<<"."<<rr.sub_error_code<<endl;
    if(rr.error_description) cerr<<"Returned: description: "<<rr.error_description<<endl;
    for(int i=0;i<rr.file.__size_url;i++) {
      cerr<<"Returned: URL: "<<rr.file.url[i]<<endl;
    };
  };
*/
  s->disconnect();
  globus_module_deactivate(GLOBUS_IO_MODULE);
  return ret;
}

