#include "../httpsd.h"
#include "../server/service_soap.h"

#include "flo_soapH.h"

#define SUCCESS                   0
#define ERR_INTERNAL_ERROR        100
#define ERR_MISSING_INPUT_DATA    1
#define ERR_EXCESSIVE_INPUT_DATA  2
#define ERR_WRONG_INPUT_DATA      3
/*
#define ERR_OBJECT_MISSING        4
#define ERR_INSUFFICIENT_ACCESS   5
#define ERR_CREATING_NEW_FILE     10
#define ERR_UPDATING_FILE         11
#define ERR_ACCESS                12
#define ERR_UNSUPPORTED_FEATURE   13
#define ERR_IMPROPER_STATE        14
*/

class FlOService;

class HTTP_FlO: public HTTP_ServiceAdv {
  friend int nf__notification(struct soap*,int,char**,struct nf__response&); 
  friend int nf__notification(struct soap*,char*,char*,struct nf__response&); 
 private:
  FlOService& s;
/*
  bool acl_create;
  bool acl_replicate;
  bool acl_read;
*/

 public:
  HTTP_FlO(HTTPS_Connector *c,FlOService& srv);
  virtual ~HTTP_FlO(void);
  virtual HTTP_Error get(const char* uri,int &keep_alive);
  virtual HTTP_Error put(const char* uri,int &keep_alive);
  //virtual HTTP_Error post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
};

HTTP_Service* flo_service_creator(HTTPS_Connector& c,const char* uri,void* arg);
bool flo_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop);

