#include "xmlwrap.h"

#include "message.h"

FlOMessage::FlOMessage(const FlOObject& o,FlOObject::action_t t):object_(o),type_(t) { };

void FlOMessage::serialize(std::string& msg) {
  XMLNode x("message");
  XMLNode x_type(x,"type");
  XMLNode x_obj(x,"object");
  XMLNode x_oid(x_obj,"id");
  XMLNode x_otype(x_obj,"type");
  switch(type_) {
    case FlOObject::created: x_type.content("created"); break;
    case FlOObject::updated: x_type.content("updated"); break;
    case FlOObject::deleted: x_type.content("deleted"); break;
  };
  switch(object_->type()) {
    case FlOObject::reference: x_otype.content("reference"); break;
    case FlOObject::ordinary:  x_otype.content("ordinary");  break;
  };
  x_oid.content(object_->id());
  msg=x.get();
}

FlOMessage* FlOMessage::deserialize(const std::string& msg) {
  XMLNode x;
  x.set(msg);
  if(!x) return NULL;
  if(x.name() != "message") return NULL;
  FlOMessage* m = NULL;
  XMLNode* x_type = x.getNode("type");
  XMLNode* x_obj = x.getNode("object");
  if((x_type != NULL) && (x_obj != NULL)) {
    XMLNode* x_oid = x_obj->getNode("id");
    XMLNode* x_otype = x_obj->getNode("type");
    if((x_oid != NULL) && (x_otype != NULL)) {
      FlOObject::action_t m_type = FlOObject::unknown;
      FlOObject::type_t m_otype = FlOObject::undefined;
      std::string cnt;
      cnt=x_type->content();
      if(cnt == "created") { m_type=FlOObject::created; }
      else if(cnt == "updated") { m_type=FlOObject::updated; }
      else if(cnt == "deleted") { m_type=FlOObject::deleted; };
      cnt=x_otype->content();
      if(cnt == "reference") { m_otype=FlOObject::reference; }
      else if(cnt == "ordinary") { m_otype=FlOObject::ordinary; };
      if((m_type != FlOObject::unknown) && (m_otype != FlOObject::undefined)) {
        FlOObject* o = new FlOObject(x_oid->content(),m_otype);
        m=new FlOMessage(*o,m_type);
      }; 
    };
    if(x_oid != NULL) delete x_oid;
    if(x_otype != NULL) delete x_otype;
  };
  if(x_type != NULL) delete x_type;
  if(x_obj != NULL) delete x_obj;
  return m;
}

