#include "xmlwrap.h"
#include "service.h"

#include "object.h"

FlOObject::FlOObject(const std::string& id,type_t t):id_(id),type_(t) {
}

FlOObject::FlOObject(FlOService& service,const std::string& id,type_t t):service_(service),id_(id),type_(t) {
  pFlOObject p(*this);
  // Add itself to service
  service.add(p);
  // Notify registered services
  service.notify(p,created);
}

FlOObject::~FlOObject(void) {
}
 
void FlOObject::serialize(std::string msg) const {
  XMLNode x("object");
  XMLNode x_id(x,"id");
  XMLNode x_type(x,"type");
  switch(type_) {
    case FlOObject::reference: x_type.content("reference"); break;
    case FlOObject::ordinary:  x_type.content("ordinary");  break;
  };
  x_id.content(id_);
  msg=x.get();
}

FlOObject* FlOObject::deserialize(std::string msg) {
  XMLNode x;
  x.set(msg);
  if(!x) return NULL;
  if(x.name() != "object") return NULL;
  FlOObject* o = NULL;
  XMLNode* x_id = x.getNode("id");
  XMLNode* x_type = x.getNode("type");
  if((x_id != NULL) && (x_type != NULL)) {
    FlOObject::type_t o_type = FlOObject::undefined;
    std::string cnt;
    cnt=x_type->content();
    if(cnt == "reference") { o_type=FlOObject::reference; }
    else if(cnt == "ordinary") { o_type=FlOObject::ordinary; };
    if(o_type != FlOObject::undefined) {
      o=new FlOObject(x_id->content(),o_type);
    };
  };
  if(x_id != NULL) delete x_id;
  if(x_type != NULL) delete x_type;
  return o;
}


FlOObject::operator bool(void) {
  return (type_ != undefined);
}

bool FlOObject::operator!(void) {
  return (type_ == undefined);
}

void FlOObject::maintain(void) {


}

void FlOObject::notification(FlOObject::action_t act,pFlOServiceRemote& srv) {
  if(type_ == reference) {
    switch(act) {
      case created: {
        // Probably propagate information and let ordinary objects 
        // decide waht to do ?

      }; break;
      case updated: {
        // Propagate notification to linked objects and services

      }; break;
      case deleted: {
        // Propagate notification to linked objects and services
 
      }; break;
    };
  } else if(type_ = ordinary) {
    switch(act) {
      case created: {
      }; break;
      case updated: {
      }; break;
      case deleted: {
      }; break;
    };
  };
}

pFlOObject FlOObject::notification(const_pFlOObject o,action_t act,pFlOServiceRemote rsrv,FlOService& srv) {
  switch(act) {
    case created:
    case updated: {
      // Decide if this object should be stored here

      // Create new object (if needed) which belongs to calling service
      FlOObject* obj = new FlOObject(srv,o->id(),reference);
    }; break;
    case deleted: {
      // Deleted and never existed
    }; break;
  };
}

