#ifndef FLO_OBJECT_H
#define FLO_OBJECT_H

#include <string>

#include "common.h"
#include "pointers.h"

/// Class to represent both reference and ordianry objects with 
/// specific methods virtual. Real object implements one or another
/// set of them.
class FlOObject: public SafeObject {
 public:
  typedef enum {
    undefined,
    reference,
    ordinary
  } type_t;
  typedef enum {
    unknown,
    created,
    updated,
    deleted
  } action_t;
 private:
  type_t type_;
  std::string id_;
  pFlOService service_;
 public:
  FlOObject(const std::string& id,type_t t = undefined);
  FlOObject(FlOService& service,const std::string& id,type_t t = undefined);
  ~FlOObject(void);
  virtual operator bool(void);
  virtual bool operator!(void);
  virtual void serialize(std::string msg) const;
  static FlOObject* deserialize(std::string msg);
  const std::string& id(void) const { return id_; };
  type_t type(void) const { return type_; };
  pFlOService service(void) { return service_; };
  virtual void notification(action_t act,pFlOServiceRemote& srv);
  virtual void maintain(void);
  static pFlOObject notification(const_pFlOObject o,action_t act,pFlOServiceRemote rsrv,FlOService& srv);
};

/*
class FlOLink {
 private:
  std::string id_;
  pFlOServiceRemote service_;
};
*/

#endif // FLO_OBJECT_H

