#include "../../std.h"


// one more hack
#define WITH_NOGLOBAL
#define SOAP_FMAC3 static
#include "flo_soapC.cpp"
#include "flo_soapClient.cpp"
#include "flo_soapServer.cpp"

#define __FLO_INTERNAL_INCLUDE__
#include "service.h"
#include "flo.h"

//#include "file_soap.nsmap"
extern SOAP_NMAC struct Namespace file_soap_namespaces[];




FlOService::FlOService(void) {

}

void FlOService::notify(pFlOObject o,FlOObject::action_t t) {
  // TODO lists must be hashed and protected
  for(list<pFlOServiceRemote>::iterator i = services.begin();i!=services.end();++i) {
    pFlOServiceRemote p = *i;
    p->notify(*o,t);
  };
}

// Process received notification
void FlOService::notification(FlOMessage& msg,pFlOServiceRemote& srv) {
  // Find object with corresponding id
  // TODO lists must be hashed and protected
  for(list<pFlOObject>::iterator i = objects.begin();i!=objects.end();++i) {
    pFlOObject p = *i;
    if(msg == p->id()) {
      p->notification(msg.type(),srv);
      return;
    };
  };
  const_pFlOObject p = msg.object();
  FlOObject::notification(p,msg.type(),srv,*this);
}

void FlOService::add(pFlOObject o) {
  objects.push_back(o);
}

pFlOServiceRemote FlOService::service(const std::string& id) {
  for(list<pFlOServiceRemote>::iterator i = services.begin();i!=services.end();++i) {
    pFlOServiceRemote p = *i;
    if(p->id() == id) return *i;
  };
  return new FlOServiceRemote("",id);
}

// ------------------------------------------------------------------
// SOAP service

bool flo_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop) {
  FlOService* srv = new FlOService();
  prop.arg=srv;
  prop.subtree=false;
}

HTTP_Service* flo_service_creator(HTTPS_Connector& c,const char* uri,void* arg){
  FlOService* srv = (FlOService*)arg;
  if(srv == NULL) return NULL;
  return new HTTP_FlO(&c,*srv);
}

#ifdef OLD_GSOAP
#error gSOAP older than 2.5.2 is not supported.
#else
void HTTP_FlO::soap_methods(void) {
  //odlog(3)<<"soap_methods: tag: "<<sp.tag<<endl;
  if(!soap_match_tag(&sp,sp.tag,"nf:notification")) soap_serve_nf__notification(&sp);
  else sp.error = SOAP_NO_METHOD;
}
#endif

HTTP_FlO::HTTP_FlO(HTTPS_Connector* c,FlOService& srv):HTTP_ServiceAdv(c),s(srv) {

}

HTTP_FlO::~HTTP_FlO(void) {

}

HTTP_Error HTTP_FlO::get(const char* uri,int &keep_alive) {
  return HTTP_NOT_IMPLEMENTED;
}

HTTP_Error HTTP_FlO::put(const char* uri,int &keep_alive) {
  return HTTP_NOT_IMPLEMENTED;
}

int nf__notification(struct soap* sp,int __size_msg,char** msg,struct nf__response &r) {
  HTTP_FlO* it = (HTTP_FlO*)(sp->user);
  // initialize response
  r.error_code=0; r.sub_error_code=0; r.error_description=NULL;
  if(__size_msg <= 0) return SOAP_OK;
  std::string dn = it->c->identity_subject();
  pFlOServiceRemote srv = it->s.service(dn);
  for(int n;n<__size_msg;n++) {
    string message(msg[n]);
    FlOMessage* m = FlOMessage::deserialize(message);
    if(m == NULL) {
      r.error_code=ERR_WRONG_INPUT_DATA; continue;
    };
    it->s.notification(*m,srv);
  };
  return SOAP_OK;
}

int nf__registration(struct soap* sp,char* url,char* filter,struct nf__response &r) {
  HTTP_FlO* it = (HTTP_FlO*)(sp->user);
  // initialize response
  r.error_code=0; r.sub_error_code=0; r.error_description=NULL;


  return SOAP_OK;
}

