#include "service.h"

// Interface to remote registered service
FlOServiceRemote::FlOServiceRemote(const std::string& url,const std::string& id):url_(url),id_(id) {
  acceptsCreatedOrdinary = true;
  acceptsCreatedReference = true;
  acceptsUpdatedOrdinary = true;
  acceptsUpdatedReference = true;
  acceptsDeletedOrdinary = true;
  acceptsDeletedReference = true;
}

FlOServiceRemote::~FlOServiceRemote(void) {

}

void FlOServiceRemote::notify(const FlOObject& o,FlOObject::action_t t) {
  // Check if service wants to accept this message
  queue_lock_.block();
  for(list<FlOMessage>::iterator i=queue_.begin();i!=queue_.end();++i) {
    if((*i) == o) {
      (*i)=t; queue_lock_.unblock(); return;
    };
  };
  queue_.push_back(FlOMessage(o,t));
  queue_lock_.unblock();
}

void FlOServiceRemote::maintain(void) {


}
