#ifndef XMLWRAP_H
#define XMLWRAP_H

#include <string>

#include <libxml/tree.h>

class XMLDocument {
 public:
  XMLDocument(void);
};

class XMLNode {
 private:
  struct _xmlNode* instance;
  bool allocated;
  XMLNode(struct _xmlNode* cur);
 public:
  XMLNode(void):instance(NULL),allocated(false) { };
  XMLNode(const std::string& name);
  XMLNode(const XMLNode& node);
  XMLNode(XMLNode& parent,const std::string& name);
  operator bool(void) { return (instance != NULL); };
  bool operator!(void) { return (instance == NULL); };
  void operator=(const XMLNode& node);
  ~XMLNode(void);
  void addNode(const XMLNode& node);
  void linkNode(XMLNode& node);
  XMLNode* getNode(int n);
  XMLNode* getNode(const std::string& name);
  int nodes(void) const;
  std::string name(void) const;
  void name(const std::string& s);
  std::string content(void) const;
  void content(const std::string& s);
  std::string get(void) const;
  void set(const std::string& s);
};

#endif // XMLWRAP_H
