#include "httpsd.h"
#include "server/service_soap.h"

#include "logger/logger_soapH.h"

#include <mysql.h>

class HTTP_Logger: public HTTP_ServiceAdv {
 friend int nl__add(struct soap *,nl__jobinfo *,int &);
 friend int nl__get(struct soap *,char*,ULONG64,array_jobinfo&);
 private:
  //HTTPS_Connector *c;
  //struct soap sp;
  //bool ignore_output;
  //bool plain_post;

  bool acl_read;
  bool acl_write;
  bool acl_query;

  MYSQL sql;

  static int local_fsend(struct soap *sp, const char* buf, size_t l);
  static size_t local_frecv(struct soap* sp, char* buf, size_t l);
  static int local_parse(struct soap *sp);
 
 public:
  HTTP_Logger(HTTPS_Connector *c,bool acl_read,bool acl_write,bool acl_query,const char* user = NULL,const char* password = NULL);
  virtual ~HTTP_Logger(void);
  virtual HTTP_Error get(const char* uri,int &keep_alive);
  virtual HTTP_Error put(const char* uri,int &keep_alive);
  virtual HTTP_Error post(const char* uri,int &keep_alive);
  virtual void soap_methods(void);
};

HTTP_Service* logger_service_creator(HTTPS_Connector& c,const char* uri,void* arg);
bool logger_service_configurator(istream& f,const char* uri,HTTP_Service_Properties &prop);

