#include "../../std.h"

#include <globus_common.h>
#include <globus_io.h>
#include <fstream>
#include <iostream>

#include "file_soap.nsmap"

#include "../client/client.h"

SOAP_NMAC struct Namespace namespaces[] =
{
  {NULL, NULL}
};

HTTP_ClientSOAP *s;

bool test = false;

ns__fileinfo::ns__fileinfo() {
  id=NULL; size=NULL; checksum=NULL;
  acl=NULL; created=NULL; state=NULL;
  __size_url=0; url=NULL;
}
ns__fileinfo::~ns__fileinfo() {
}




int main(int argc,char* argv[]) {
  char* url = argv[1];
  if(url == NULL) { cerr<<"URL missing"<<endl; return -1; };
  char* lfn = argv[2];
  if(lfn == NULL) { cerr<<"LFN missing"<<endl; return -1; };
  char* source = argv[3];
  if(source == NULL) { cerr<<"Source URL missing"<<endl; return -1; };
  int ret = -1;

  if(globus_module_activate(GLOBUS_IO_MODULE) != GLOBUS_SUCCESS) {
    cerr<<"Failed to activate globus"<<endl; return -1;
  };

  int r;
  struct soap soap;

  int soap_err = SOAP_OK;

  // initialize interface
  s = new HTTP_ClientSOAP(url,&soap);
  soap.namespaces=file_soap_namespaces;

  if(s->connect() != 0) {
    cerr<<"Failed to connect to "<<url<<endl;
    return -1;
  };

  ns__fileinfo info;
  unsigned long long int size_ = 2000;
  info.id=lfn; info.size=&size_;
  info.checksum=NULL;
  info.acl="<?xml version=\"1.0\"?><gacl version=\"0.0.1\"><entry><any-user></any-user><allow><write/><read/><list/><admin/></allow></entry></gacl>";
  ns__addResponse rr;
  if((soap_err=soap_call_ns__add(&soap,url,"add",&info,1,&source,rr)) != SOAP_OK) {
    cerr<<"Failed to create remote file: "<<soap_err<<endl;
  } else {
    cerr<<"Returned: error code "<<rr.error_code<<"."<<rr.sub_error_code<<endl;
    if(rr.error_description) cerr<<"Returned: description: "<<rr.error_description<<endl;
    for(int i=0;i<rr.file.__size_url;i++) {
      cerr<<"Returned: URL: "<<rr.file.url[i]<<endl;
    };
  };
  s->disconnect();
  globus_module_deactivate(GLOBUS_IO_MODULE);
  return ret;
}

