#include "../../std.h"

#include <ldap.h>

#include "../../misc/url_options.h"
#include "file.h"
#include "se_ns.h"

class SENameServerLRC: public SENameServer {
 private:
  bool valid;
  LockSimple lock;
  list<string> urls;
 public:
  SENameServerLRC(const char* contact,const char* se_url);
  virtual ~SENameServerLRC(void);
  virtual int Register(SEFile& file,bool require_unique);
  virtual int Unregister(SEFile& file,bool allow_last);
  virtual int Modify(SEFile& file);
  virtual int Get(SEAttributes& file);
  virtual int Maintain(void);
  virtual operator bool(void) { return valid; };
  virtual string url(SEAttributes& file);
};

