#include "../std.h"
#include "globus_error_utils.h"

/*
ostream& operator<<(ostream& o,globus_result_t res) {
  if(res == GLOBUS_SUCCESS) {
    o<<"<success>"; return o;
  };
  globus_object_t* err = globus_error_get(res);
  if(err) {
    char* tmp=globus_object_printable_to_string(err);
    if(tmp) { o<<tmp; free(tmp); };
    globus_object_free(err);
  };
  return o;
}
*/

ostream& operator<<(ostream& o,GlobusResult res) {
  if(res == GlobusResult(GLOBUS_SUCCESS)) {
    o<<"<success>"; return o;
  };
  globus_object_t* err = globus_error_get(res);
  if(err) {
    char* tmp=globus_object_printable_to_string(err);
    if(tmp) { o<<tmp; free(tmp); };
    globus_object_free(err);
  };
  return o;
}

ostream& operator<<(ostream& o,globus_object_t* err) {
  if(err == GLOBUS_NULL) {
    o<<"<success>"; return o;
  };
  char* tmp=globus_object_printable_to_string(err);
  if(tmp) { o<<tmp; free(tmp); };
  return o;
}

static struct {
  char* str;
  int code;
} gass_errors[] = {
{ "Invalid port in URL", GLOBUS_GASS_TRANSFER_ERROR_BAD_PORT },
{  "Something bad occurred while processing the request", GLOBUS_GASS_TRANSFER_ERROR_INTERNAL_ERROR },
{ "Unparsable URL", GLOBUS_GASS_TRANSFER_ERROR_BAD_URL },
{ "Invalid file open mode in the GASS File library", GLOBUS_GASS_TRANSFER_ERROR_NOT_SUPPORTED },
{ "Operation not supported by GASS for this type of URL", GLOBUS_GASS_TRANSFER_ERROR_NOT_IMPLEMENTED },
{ "Out of memory", GLOBUS_GASS_TRANSFER_ERROR_MALLOC_FAILED },
{ "Uninitialized or invalid handle", GLOBUS_GASS_TRANSFER_ERROR_NOT_INITIALIZED },
{ "NULL pointer passed as parameter", GLOBUS_GASS_TRANSFER_ERROR_NULL_POINTER },
{ "GASS Server not yet registered", GLOBUS_GASS_TRANSFER_ERROR_NOT_REGISTERED },
{ "URL not in cache", GLOBUS_GASS_TRANSFER_ERROR_NOT_FOUND },
{ "Invalid use of a GASS handle", GLOBUS_GASS_TRANSFER_ERROR_INVALID_USE },
{ "Bytes array exceeds GASS request size", GLOBUS_GASS_TRANSFER_ERROR_TOO_LARGE },
{ "GASS Transfer request did not complete successfully", GLOBUS_GASS_TRANSFER_ERROR_REQUEST_FAILED },
{ "GASS handle already closed before this operation began", GLOBUS_GASS_TRANSFER_ERROR_DONE },
{ "GASS handle already registered for processing", GLOBUS_GASS_TRANSFER_ERROR_ALREADY_REGISTERED },
{ "Could not open local file", GLOBUS_GASS_TRANSFER_ERROR_OPEN_FAILED },
{ "A protocol error or client-initiated failure has occurred", GLOBUS_GASS_TRANSFER_ERROR_TRANSFER_FAILED },
{ NULL, 0 }
};

const char* globus_gass_error_string(int n) {
  for(int i = 0;gass_errors[i].str != NULL;i++) {
    if(gass_errors[i].code == n) return gass_errors[i].str;
  };
  return "";
}

