#ifndef GM_LOG_TIME_H
#define GM_LOG_TIME_H

#include "../std.h"
#include <iostream>
#include <string>

/*
  Object and macros to control output.
  olog/odlog are used instead of cerr.
  LogTime::level allows to control which messages are printed.
  If LogTime::active is set, date+time will be added at the beginning
  of message.
*/

#define olog cerr<<LogTime()
#define olog_ cerr
#define odlog(l) if(l<=LogTime::level) cerr<<LogTime()
#define odlog_(l) if(l<=LogTime::level) cerr
#define odilog(l,i) if(l<=LogTime::level) cerr<<LogTime(i)
#define odilog_(l) if(l<=LogTime::level) cerr
#define oilog(i) cerr<<LogTime(i)
#define oilog_ cerr

class LogTime {
 friend ostream& operator<<(ostream&,LogTime);
 private:
  int id;
  static string logname;
  static int lognum;
  static unsigned int logsize;
  static pthread_mutex_t mutex;
 public:
  static bool active;
  static int level;
  LogTime(void);
  LogTime(int);
  static void Log(const char* name = "",unsigned int size = 0,int num = 0);
  static void rotate(void);
  static void gmdatetime(ostream& o);
};

ostream& operator<<(ostream& o,LogTime t);

#endif
