#include "std.h"
#include <dlfcn.h>
#include <iostream>

#include "ngdata.h"


#ifdef NG_WRAPPER
#include "../userinterface/wrapper.cpp"

typedef int (*func_t)(int argc,char** argv);

int main(int argc,char** argv) {
  if(!getenv("NORDUGRID_ENVIRONMENT_SETUP")) wrapper(argv);
  const char *progname = strrchr(argv[0],'/');
  if(progname == NULL) { progname=argv[0]; } else { progname++; };

  string path = getenv("NORDUGRID_LOCATION");
  if(path.length() == 0) { path="libngdata.so"; }
  else { path+="/lib/libngdata.so"; };
  void* plugin = dlopen(path.c_str(),RTLD_NOW);
  if (!plugin) {
    cerr<<"Error loading shared library: "<<dlerror()<<endl;
    return 1;
  };
  func_t func;
  if(!strncmp(progname,"ngcopy",6)) {
    func=(func_t)dlsym(plugin,"ngcopy");
  } else if(!strncmp(progname,"ngremove",8)) {
    func=(func_t)dlsym(plugin,"ngremove");
  } else if(!strncmp(progname,"ngacl",5)) {
    func=(func_t)dlsym(plugin,"ngacl");
  } else if(!strncmp(progname,"ngls",5)) {
    func=(func_t)dlsym(plugin,"ngls");
  } else {
    cerr<<"Calling what ?"<<endl;
    return 1;
  };
  if(func == NULL) {
    cerr<<"Failed to find function "<<progname<<": "<<dlerror()<<endl;
    return 1;
  };
  return (*func)(argc,argv);
}
#else

#include <iostream>

int main(int argc,char** argv) {
  const char *progname = strrchr(argv[0],'/');
  if(progname == NULL) { progname=argv[0]; } else { progname++; };
  if(!strncmp(progname,"ngcopy",6)) return ngcopy(argc,argv);
  if(!strncmp(progname,"ngremove",8)) return ngremove(argc,argv);
  if(!strncmp(progname,"ngacl",5)) return ngacl(argc,argv);
  if(!strncmp(progname,"ngls",4)) return ngls(argc,argv);
  cerr<<"Calling what ?"<<endl;
  return 1;
}
#endif
