#include "../jobs/users.h"
#include "../files/info_files.h"
#include "../files/info_types.h"
#include <globus_common.h>
#include <globus_rsl.h>

bool parse_rsl_for_action(const char* fname,string &action_s,string &jobid_s,string &lrms,string &queue);
bool parse_rsl(const string &fname,JobLocalDescription &job_desc,string* acl = NULL);
bool preprocess_rsl(const string &fname,const string &session_dir,const string &jobid);
bool process_rsl(JobUser &user,const JobDescription &desc);
bool process_rsl(JobUser &user,const JobDescription &desc,JobLocalDescription &job_desc);
bool write_grami(const JobDescription &desc,const JobUser &user,const string &session_dir,JobLocalDescription &job_desc,const char *opt_add = NULL);
string read_grami(const JobId &job_id,const JobUser &user,const string &session_dir);
bool set_execs(const JobId &job_id,const JobUser &user,const string &session_dir);
globus_rsl_t* read_rsl(const string &fname);

#define NG_RSL_ACTION_PARAM       "action"
#define NG_RSL_LRMS_PARAM         "lrmstype"
#define NG_RSL_QUEUE_PARAM        "queue"
#define NG_RSL_INPUT_DATA_PARAM   "inputfiles"
#define NG_RSL_OUTPUT_DATA_PARAM  "outputfiles"
#define NG_RSL_ARGUMENTS_PARAM    "arguments"
#define NG_RSL_EXECUTABLES_PARAM  "executables"
#define NG_RSL_JOB_ID_PARAM       "jobid"
#define NG_RSL_REPLICA_PARAM      "replicacollection"
#define NG_RSL_LIFETIME_PARAM     "lifetime"
#define NG_RSL_NOTIFY_PARAM       "notify"
#define NG_RSL_STARTTIME_PARAM    "starttime"
#define NG_RSL_RUNTIME_PARAM      "runtimeenvironment"
#define NG_RSL_JOBNAME_PARAM      "jobname"
#define NG_RSL_RERUN_PARAM        "rerun"
#define NG_RSL_FTPTHREADS_PARAM   "ftpthreads"
#define NG_RSL_CACHE_PARAM        "cache"
#define NG_RSL_HOSTNAME_PARAM     "hostname"
#define NG_RSL_SOFTWARE_PARAM     "clientsoftware"
#define NG_RSL_STDIN_PARAM        "stdinput"
#define NG_RSL_STDIN_PARAM2       "sstdin"
#define NG_RSL_STDLOG_PARAM       "gmlog"
#define NG_RSL_DISKSPACE_PARAM    "disk"
#define NG_RSL_COUNT_PARAM        "count"
#define NG_RSL_CPUTIME_PARAM      "cputime"
#define NG_RSL_MEMORY_PARAM       "memory"
#define NG_RSL_JOBREPORT_PARAM    "jobreport"
#define NG_RSL_ACL_PARAM          "acl"

