#ifndef __URL_MAP_H__
#define __URL_MAP_H__

#include <string>
#include <list>

class UrlMap {
 private:
  class map_entry {
   public:
    string initial;
    string replacement;
    string access;
    map_entry(void):initial(""),replacement(""),access("") {
    };
    map_entry(const string &templ,const string &repl,const string &accs = "") {
      initial=templ; replacement=repl; access=accs;
    };
    map_entry(const char* templ,const char* repl,const char* accs = "") {
      initial=templ; replacement=repl; access=accs;
    };
  };
  list<map_entry> entries;
 public:
  UrlMap(void);
  ~UrlMap(void);
  bool map(string &url) const;
  bool local(const string &url) const;
  void add(const string &templ,const string &repl,const string &accs = "");
  void add(const char* templ,const char* repl,const char* accs = "");
};

#endif
