/*
  
   Copyright 2004 Jonas Bardino

   This file is part of NorduGRID GridSSH.

    NorduGRID GridSSH is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    NorduGRID GridSSH is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NorduGRID GridSSH; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __EXPIRE_QUEUE_H__
#define __EXPIRE_QUEUE_H__

#include <globus_common.h> /* mutex */
#include <time.h>

/* Expire modes */
#define NEVER_EXPIRE 0
#define PROXY_EXPIRE 1
#define AGGRESSIVE_EXPIRE 2

typedef struct expire_element {
  struct expire_element *next;
  char *auth_filename;
  char *pubkey;
  int expire;
} expire_elem;


typedef struct expire_q {
  expire_elem *queue;
  globus_mutex_t lock;
  time_t next;
} expire_queue;

/* Prototypes */
int initialize_expire_q(void);
int finalize_expire_q(void);
int check_expire(void);
int sched_expire(char *key, char *filename, time_t time);

#endif
