/*
  
   Copyright 2004 Jonas Bardino

   This file is part of NorduGRID GridSSH.

    NorduGRID GridSSH is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    NorduGRID GridSSH is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NorduGRID GridSSH; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __LOG_H__
#define __LOG_H__
/*
  Headers for log.c

  2004, Jonas Bardino

*/

#include <stdarg.h>

/* according to man ctime string len should be at least 26 */
#define TIME_STR_LEN 26 

int initialize_log(char *out, char *err);
int finalize_log(void);


/* Make sure all debugmsg() are ignored if not in debugmode */
#ifndef __DEBUG_MODE__
/* This variable argument list in a macro is not strictly ANSI C89 but it works */
#define debugmsg(lvl, fmt, ...); /* nop */
#define debug_sleep(lvl, secs); /* nop */
#else
void debugmsg(int lvl,char *fmt, ...);
void debug_sleep(int lvl, unsigned int secs);
#endif

#ifdef COLORDEBUG
void setfgcolor(int colornum);
#endif

void errmsg(char *fmt, ...);
void warnmsg(int lvl, char *fmt, ...);
void showmsg(char *fmt, ...);
void showstr(char *fmt, ...);

#endif
