#!/usr/bin/perl
use lib "$ENV{PWD}/";
use lib "$ENV{NORDUGRID_LOCATION}/libexec";
use lib "/opt/nordugrid/libexec";
use infosys_shared;
use InfosysCluster qw(%config &clusterldif);
#use warnings;

# populates the nordugrid-cluster LDAP entry with real GM and config but
# dummy LRMS values (13, 66 or "dummy"). 
# The GM interface is factored into the InfosysCluster module.
# Use this template to port the infosys.
# Don't use 'my xyz' for the interfacing GLOBAL variables!


#<LRMSPORT
# automatically determine the LRMS name(flavour) and version
#dummy values for testing
$lrms_type = "DUMMY LRMS";
$lrms_version = "13.0";
#LRMSPORT>


#<LRMSPORT
# Calculate the totalcpus & cpudistribution & number of used cpus
# by collecting information from the LRMS
# Consult the schema for the syntax of the $cpudistribution
# If $dedicated_node_string is set, nondedicated nodes, which are not marked with 
# $dedicated_node_string should be skipped
#dummy values for a "1cpu:13 13cpu:1" always "free" test cluster of 14 nodes
$totalcpus = 13;
$usedcpus = 13;
$cpudistribution = "1cpu:13 13cpu:1";
#LRMSPORT>


#<LRMSPORT
# Calculate $lrms_queued, the number of jobs (both grid and nongrid) 
# being queued in the LRMS 
# dummy value for testing
$lrms_queued = 13;
#LRMSPORT>


#<LRMSPORT
# Calculate the total number of jobs in the LRMS (running, queued, hold, being in any LRMS state;
# submitted by both grid and nongrid users): $lrms_total
# dummy value for testing:
$lrms_total = 13;
#LRMSPORT>


# generating the cluster ldif  
&clusterldif;


# some performance test
my $runtime =  time - $^T;
if ($config{loglevel} == 2) {
   &infosys_shared::write_log("execution time: $runtime");
}
elsif ($config{loglevel} == 1 and $runtime >= 4 ) {  
   &infosys_shared::write_log("SLOW script: $runtime");  
}
   

exit;
