"""
This module provides a library for various data management tasks.
"""


import arcbindings as arc
import logger
import errors


class DataError(errors.ARCError):
	"""
	Raised when an error occurs during the movement or handling of data.
	"""
	pass

	
def download_output_files(jobid, download_dir, remove_files = False):
	"""
	Given a jobid and an download directory this funtion will fetch
	the output files from a job to the output directort.
	The optional remove_files indicates whether the output files should
	be removed.
	"""
	log = logger.Logger()
	log.debug("Download output files from %s to %s" % (jobid, download_dir))

	esv = arc.string_vector()
	error = arc.ui_download(jobid, True, download_dir, esv,
	                        True, remove_files, 0, 40)
	if error:
		raise DataError("Error downloading files from job %s" % jobid)

