"""
This file contains all general exceptions for the Advanced Resource
Manager (ARC). Modules may (and should) define their own exceptions
as well, but if the exceptions is "general" to a certain degree,
it is okay to put it in here.
"""


import exceptions


class ARCError(exceptions.Exception):
	"""
	All the exceptions in the ARC should
	inherit from this exception. Try not to create
	an exception for each unique error condition,
	but one for each "class" of errors.
	"""


class JobidError(ARCError):
	"""
	Raised when an invalid jobid is passed along.
	"""

