#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <vector>

#include "LdapQuery.h"

#ifndef UI_GIIS
#define UI_GIIS

class Giis {

 public:
  Giis () {};   // Added because of Swig
  Giis (const string & url);
  Giis (const string & host_, int port_, const string & basedn_);
  ~Giis () {};
  bool operator== (const Giis & giis) const;
  bool operator! () const;
  int Connect (const string & usersn, bool anonymous,
	       int timeout, int debug = 0);
  int Query (const string & usersn, int timeout, int debug = 0);
  int Result (void callback (const string & attr,
			     const string & value,
			     void * ref),
	      void * ref, int timeout, int debug = 0);
 private:
  string host;
  int port;
  string basedn;
  LdapQuery ldap;
};


int GetGiises (const vector <string> & giisurls, vector <Giis> & giislist);

#endif
